<?php


use Greenter\Ws\Services\ConsultCdrService;
use Greenter\Ws\Services\SoapClient;
include('../init.php');
include "config.php";

require __DIR__ . '/../vendor/autoload.php';



try{
 
    $json = array();
     // URL CDR de Producción
    $wsdlUrl = 'https://e-factura.sunat.gob.pe/ol-it-wsconscpegem/billConsultService?wsdl';
    $soap = new SoapClient($wsdlUrl);
    $soap->setCredentials($_POST['rucSol'].$_POST['userSol'], $_POST['passSol']);
   
    $service = new ConsultCdrService();
    $service->setClient($soap);
    
    $rucEmisor =$_POST['rucSol'];
    $tipoDocumento = '01'; // 01: Factura, 07: Nota de Crédito, 08: Nota de Débito
    $serie = $_POST['serie'];
    $correlativo = $_POST['numero'];
    
    $result = $service->getStatusCdr($rucEmisor, $tipoDocumento, $serie, $correlativo);
   
    if (!$result->isSuccess()) {
         //throw new Exception("Error " . $result->getCode() . " | " .$result->getMessage());
        var_dump($result->getError());
        return;
    }
    
    $cdr = $result->getCdrResponse();
   
    if ($cdr === null) {
        
        $json["success"] = false;
        $json['codigo'] = -1;
        $json['message'] = 'CDR no encontrado, el comprobante no ha sido comunicado a SUNAT.';
        
    }else{
          //print_r($cdr->getDescription());
        $json["success"] = true;
        $json['codigo'] = $cdr->getCode();
        $json['message'] = $cdr->getDescription();
        
        $nDocumento= $_POST['serie'].'-'.$_POST['numero'];
        $db = new conexion();
        $link = $db->conexion();
        $link->query("UPDATE al_venta SET codigo_respuesta = 0, mensaje_respuesta ='El comprobante fue aceptado', enviado=2 
        WHERE documento ='$nDocumento' ");
        
         $fileDir = __DIR__ . '/../admin/FE/CDR/';
         $filename='R-'.$rucEmisor.'-01-'.$serie.'-'.$correlativo.'.zip';

        if (!file_exists($fileDir)) {
            mkdir($fileDir, 0777, true);
        }
        $pathZip = $fileDir.DIRECTORY_SEPARATOR.$filename;
    
        file_put_contents($pathZip, $result->getCdrZip());
        
    }
    

    echo json_encode($json);
    
}catch(Exception $e){
    $json = array();
    $json["sucess"] = false;
    $json['codigo'] = $e->getCode();
    $json['message'] = $e->getMessage();
    echo json_encode($json);
}


  
    
//file_put_contents('R-20000000001-01-F001-1.zip', $result->getCdrZip());


?>